routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\WarehouseController;
use App\Http\Controllers\SalesPointController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\StockController;
use App\Http\Controllers\SalesPointStockController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {return view('dashboard');})->middleware(['auth'])->name('dashboard');


Route::group(['middleware' => 'auth'], function() {

    //warehousse route
    Route::get('warehouses/archiver/{id}',[WarehouseController::class,'archiver'])->name('warehouses.archiver');
   
   //salespoint route
   Route::get('salespoint/archiver/{id}',[SalesPointController::class,'archiver'])->name('salespoint.archiver');
   
   Route::get('salespoint/newslot',[SalesPointController::class,'newslot'])->name('salespoint.newslot');
   Route::post('stocks/newslotsave',[SalesPointController::class,'newslotsave'])->name('salespoint.newslotsave');
    
   
   //product route
   Route::get('product/archiver/{id}',[ProductController::class,'archiver'])->name('product.archiver');
   
   //clients route
   Route::get('client/archiver/{id}',[ClientController::class,'archiver'])->name('client.archiver');
    //stock transfer to warehouse route
   Route::get('stocks/transfer/{id}',[StockController::class,'transfer'])->name('stocks.transfer');
   Route::post('stocks/saveTransfer',[StockController::class,'saveTransfer'])->name('stocks.saveTransfer');
   //stock transfer to salespoint route
    Route::get('stocks/transferSales/{id}',[SalesPointStockController::class,'transferSales'])->name('stocks.transferSalespoint');
    Route::post('stocks/saveTransferSales',[SalesPointStockController::class,'saveTransferSales'])->name('stocks.saveTransferSales');
    
   Route::resource('warehouses', WarehouseController::class);

    // sales point route
    Route::resource('salespoint', SalesPointController::class);


    // product route
    Route::resource('product', ProductController::class);
    // client route
    Route::resource('client', ClientController::class);

    // stock route stocks.getSlots
    Route::post('stocks/getSlots',[StockController::class,'getSlots'])->name('stocks.getSlots');
    Route::resource('stocks', StockController::class);
});

require __DIR__.'/auth.php';

app/Models/SalesPoint.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class SalesPoint extends Model
{
    use HasFactory;
    public function somme()
    {
        return SalesPointStock::where('sales_point_id',$this->id)->sum('quantity');
    }

}

app/Http/Controllers/SalesPointController.php
<?php

namespace App\Http\Controllers;

use App\Models\Lot;
use App\Models\Stock;
use App\Models\SalesPointStock;
use App\Models\Product;
use App\Models\Warehouse;
use App\Models\SalesPoint;
use Illuminate\Http\Request;
use Psy\Readline\Hoa\Console;

class SalesPointController extends Controller
{
    //
    public function index()
    {

        $stock = SalesPoint::where('stat',1)->get();
        $stocks = Stock::all();
        $products =Product::where('stat',1)->get();
        $warehouses =Warehouse::where('stat',1)->get();
        $salesStock = SalesPointStock::get();
        //dd($stock);
        $sum = SalesPointStock::sum('quantity');

       // dd($sum);
        //->sum('quantity')

       return view('salespoint.index', ['sales_points' => $stock,'warehouses'=> $warehouses ,
       'products'=>$products, 'stocks' => $stocks,'sum'=>$sum ]);
    }
    public function create()
    {
        return view('salespoint.create');
    }
    public function store(Request $req )
    {
        //dd($req);
        $req->validate([
            'name' => 'required',
            'emplacement' => 'required',
          ]);
         //$modif=true;
         $coffee = SalesPoint::find($req->id);
        

         if(!$coffee){
           $coffee = new SalesPoint;
         }  
        $coffee->name=$req->name;
        $coffee->emplacement=$req->emplacement;
        $coffee->save();

        
        // get the id of the salespoint saved
        $newSalespointId = $coffee->id;

        // search in salespointstock 
       $foundSalespointStock= SalesPointStock::find($newSalespointId);
        // if found do nothing
        // if not found
        // create new salespointstock with the id of salespoint saved 
        if(!$foundSalespointStock){
         $s =  new SalesPointStock;
            $s->sales_point_id = $newSalespointId;
            $s->product_id  = "";
            $s->quantity = 0;
           
            $s->save();
        }

        return redirect()->route('salespoint.index');
    }
    
    // the edit function of warehouse
    public function edit($id)
    {
        $model = SalesPoint::find($id);
        return view('salespoint.create',['model'=> $model]);
    }
    // the archive function of warehouse
    public function archiver($id)
    {
        $model = SalesPoint::find($id);
        $model->stat='0';
        $model->save();
        return redirect()->route('salespoint.index');
    }
    public function show($id){

             // $id == sales_point_id 
       //$products_in_salepoint = SalesPointStock::where('sales_point_id',$id)->get();

       $salespoint_name = SalesPoint::find($id);
       $lots = Lot::where('salespoint',(string)$id)->get();
       //dd($lots);
       //dd($salespoint_name->name);
       /* foreach($products_in_salepoint as $pr)
       {
        if ($pr->quantity <20)
       {
        session()->flash('message', 'the stock is less than the minimum quantity');
       }
       } */
        return view('salespoint.detail', ['lots' => $lots,
        'salespoint_name' => $salespoint_name ] );
    }

    public function newslot()
    {
        //dd($req);
        $salespoint_name = SalesPoint::get();
       // dd($salespoint_name);
          return view('salespoint.newslot', ['salespoint_name' =>$salespoint_name]);
    }

    public function newslotsave(Request $req)
    {
        
        $lots = new Lot;
          
        $lots->name=$req->name;
        $lots->salespoint=$req->salespoint;
        //dd($lots);
        $lots->save();
        return redirect()->route('salespoint.index');
    }
}

resources/views/salespoint/create.blade.php
@extends('layouts.app')

@section('content')
<style>
   .view{
      width: 400px;
      
   }
</style>
<div class="view mt-4">
    <h1 class="mb-4">New SalesPoint</h1>
    <form action="{{route('salespoint.store')}}" method="post">
        @csrf
    <div class="form-group">
       <label for="salespoint" >SalesPoint Name</label>
       <input type="text" name="name" value="{{@$model->name}}" class="form-control" required>
    </div>
    <div class="form-group mb-2">
       <label for="emplacement">Emplacement</label>
       <textarea required name="emplacement"  class="form-control" >{{@$model->emplacement}} </textarea>
    </div>
    <input name="id" value="{{@$model->id}}"  type="hidden">
    <a href="{{route('salespoint.index')}}" class="btn btn-secondary">Cancel</a>
    <button type="submit" class="btn btn-primary" style="background: blue">Save</button>
    </form>
   </div>
@endsection

resources/views/salespoint/detail.blade.php
@extends('layouts.app')

@section('content')

<div class="mt-4">
  
    <h3><span style="font-weight: bold;">
         {{ucfirst($salespoint_name->name)}}</span> Details :  </h3>
    <a href="{{URL::previous()}}" class="btn btn-secondary my-3" >back</a>
    <a href="{{route('salespoint.newslot')}}"  class="btn btn-success">New Slot</a>
   
    <table class="table  table-striped table-bordered taille" >
        <thead>
            <tr>
                <th>Slots List</th>
                <th>Products</th>
                <th>Quantity</th>
            </tr>
        </thead>
        <tbody>
         
         @foreach ($lots as $pr)
            <tr>
                
                <td>{{ $pr->name}}</td>
                <td>{{ $pr->product}}</td>
                <td>
                    {{$pr->quantity}}
                </td> 
                 
            </tr>
         @endforeach
              </tbody>
    </table>

@endsection

resources/views/salespoint/index.blade.php
@extends('layouts.app')

@section('content')
<style>
   
    .taille{
        max-width: auto;
    }

    .icon-button {
  position: relative;
  display: flex;
  align-items: center;
  justify-content: center;
  width: 40px;
  height: 40px;
  color: #333333;
  background: #dddddd;
  border: none;
  outline: none;
  border-radius: 50%;
}

.icon-button:hover {
  cursor: pointer;
}

.icon-button:active {
  background: #cccccc;
}

.icon-button__badge {
  position: absolute;
  top: -6px;
  right: -6px;
  width: 20px;
  height: 20px;
  background: red;
  color: #ffffff;
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 50%;
}
</style>

    <div class="mt-4">
        
    <a href="{{route('salespoint.create')}}" class="btn btn-success">New Salespoint</a>
    </div>
    <div class="mt-4">
        <table class="table  table-striped table-bordered taille" >
            <thead>
                <tr>
                    <th>Salespoint Name</th>
                    <th>Emplacement</th>
                    <th>Quantity</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($sales_points as $stock)
                <tr>
                    <td>{{ $stock->name }}</td>
                    <td>{{$stock->emplacement}}</td>
                      <td>
                        <span>{{$stock->somme()}}</span> 
                      </td>
                        <td>
                        <a href="{{route('salespoint.archiver',$stock->id)}}" class="btn btn-secondary">Achive</a>
                        <a href="{{route('salespoint.edit',$stock->id)}}" class="btn btn-info">Edit</a>
                        <a href="{{route('salespoint.show',$stock->id)}}" class="btn btn-success">Detail</a>
                       <!-- <a href=""  class="btn btn-danger">Delete</a>-->
                    </td>
                </tr>
                @endforeach
            </tbody>
        </table>
    </div>

 
@endsection

resources/views/salespoint/newslot.blade.php
@extends('layouts.app')

@section('content')
<style>
   .view{
      width: 400px;
      
   }
</style>
<div class="view mt-4">
    <h1 class="mb-4">New Slot</h1>
    <form action="{{route('salespoint.newslotsave')}}" method="post">
        @csrf
    <div class="form-group mb-2">
        <label for="salespoint" >Salespoint</label>
        <select name="salespoint" id="salespoint" class="form-control" required>
           <option  readonly>Selectionnez une machine</option>
          @foreach($salespoint_name as $sa)
          <option value="{{$sa->id}}">{{$sa->name}}</option>
          @endforeach
        </select>
       
    </div>
    <div class="form-group mb-2">
       <label for="name" >Slot Name</label>
       <input type="text" name="name" value="" class="form-control" required>
    </div>
    
    <a href="{{route('salespoint.index')}}" class="btn btn-secondary">Cancel</a>
    <button type="submit" class="btn btn-primary" style="background: blue">Save</button>
    </form>
   </div>
@endsection